VERSION 5.00
Begin VB.Form About 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "About..."
   ClientHeight    =   4890
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   5775
   ClipControls    =   0   'False
   HasDC           =   0   'False
   Icon            =   "About.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4890
   ScaleWidth      =   5775
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   14.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000C0C0&
      HasDC           =   0   'False
      Height          =   3375
      Left            =   120
      ScaleHeight     =   223
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   367
      TabIndex        =   2
      Top             =   120
      Width           =   5535
   End
   Begin VB.CommandButton cmdOK 
      Cancel          =   -1  'True
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   4275
      TabIndex        =   1
      Top             =   3900
      Width           =   1260
   End
   Begin VB.CommandButton cmdSysInfo 
      Caption         =   "&System Info..."
      Height          =   345
      Left            =   4290
      TabIndex        =   0
      Top             =   4320
      Width           =   1245
   End
   Begin VB.Label Label1 
      Caption         =   "http://www.outwar.com/page.php?x=1648402"
      ForeColor       =   &H00FF0000&
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   4560
      Width           =   3975
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808080&
      BorderStyle     =   6  'Inside Solid
      Index           =   1
      X1              =   120
      X2              =   5685
      Y1              =   3720
      Y2              =   3720
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00FFFFFF&
      Index           =   0
      X1              =   135
      X2              =   5670
      Y1              =   3735
      Y2              =   3735
   End
   Begin VB.Label lblDisclaimer 
      Caption         =   $"About.frx":000C
      ForeColor       =   &H00000000&
      Height          =   825
      Left            =   120
      TabIndex        =   3
      Top             =   3900
      Width           =   3975
   End
End
Attribute VB_Name = "About"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' This program automates different actions within Outwar, an RPG-game.
'Copyright (C) 2004  Kristian S.Stangeland
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Dim Stjerner(300) As Stjerner
Dim Looping As Boolean
Dim Buffer As Buffer

Private Type Stjerner
x As Double
y As Double
r As Byte
Color As Long
End Type

Private Type Line
Text As String
Style As Long
End Type

Dim Roller() As Line
Dim lCount As Long

Private Sub Form_Initialize()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Form_Initialize()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

EventStarted "Initialize", Me
HookWindow Me.hwnd

End Sub

Private Sub cmdOK_Click()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "cmdOK_Click()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

UnLoadBuffer
Looping = False
About.Hide

End Sub

Private Sub cmdSysInfo_Click()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "cmdSysInfo_Click()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

StartSysInfo

End Sub

Private Sub Form_Load()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Form_Load()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

LoadStjerner

End Sub

Sub LoadStjerner()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "LoadStjerner()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim A%
For A = 0 To UBound(Stjerner)
Stjerner(A).x = Rnd * Picture1.ScaleWidth
Stjerner(A).y = Rnd * Picture1.ScaleHeight
Stjerner(A).r = Rnd * 255
Stjerner(A).Color = RGB(Stjerner(A).r, Stjerner(A).r, Stjerner(A).r)
Next

End Sub

Sub LoadBuffer()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "LoadBuffer()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

UnLoadBuffer
Buffer.hdc = CreateCompatibleDC(About.hdc)
Buffer.Picture = CreateCompatibleBitmap(About.hdc, Picture1.ScaleWidth, Picture1.ScaleHeight)
SelectObject Buffer.hdc, Buffer.Picture
Buffer.ScaleWidth = Picture1.ScaleWidth
Buffer.ScaleHeight = Picture1.ScaleHeight

End Sub

Sub UnLoadBuffer()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "UnLoadBuffer()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

DeleteDC Buffer.hdc
DeleteObject Buffer.Picture

End Sub

Sub MainLoop()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "MainLoop()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim A%, y As Double
Dim Rect As Rect, Arthor As String

' To prevent someone changing the name
Arthor = HexToString("%4B%72%69%73%74%69%61%6E%2E%53%2E%53%74%61%6E%67%65%6C%61%6E%64")

Show
Looping = True
LoadBuffer

SetBkMode Buffer.hdc, 1
SetTextColor Buffer.hdc, &HC0C0&

y = Picture1.ScaleHeight

Do Until Looping = False
BitBlt Buffer.hdc, 0, 0, Buffer.ScaleWidth, Buffer.ScaleHeight, 0, 0, 0, vbWhiteness

y = y - 0.5

For A = 0 To UBound(Stjerner)
Stjerner(A).y = Stjerner(A).y - (Stjerner(A).r / 100)
If Stjerner(A).y < 0 Then Stjerner(A).y = Buffer.ScaleHeight
SetPixelV Buffer.hdc, Stjerner(A).x, Stjerner(A).y, Stjerner(A).Color
Next

ClearRollerText
AddRollerLine "The developer:", FW_BOLD
AddRollerLine Arthor, FW_NORMAL
AddRollerLine "", 0
AddRollerLine "The beta-testers:", FW_BOLD
AddRollerLine Arthor, FW_NORMAL
AddRollerLine "Christopher Williams", FW_NORMAL
AddRollerLine "Alex Field", FW_NORMAL
AddRollerLine "Mikkel Brekne Munkvold", FW_NORMAL
AddRollerLine "Stephan Guderian", FW_NORMAL
AddRollerLine "", 0
AddRollerLine "Pyschological Help:", FW_BOLD
AddRollerLine "Christopher Williams", FW_NORMAL
AddRollerLine "", 0
AddRollerLine "Name adviser:", FW_BOLD
AddRollerLine "Christopher Williams", FW_NORMAL
AddRollerLine "", 0
AddRollerLine "Developed the year 2004", FW_NORMAL
AddRollerLine "Please give me thugs!", FW_NORMAL
AddRollerLine "", 0
AddRollerLine "Using auto-attackers is", FW_NORMAL
AddRollerLine "illegal and i'm not resposible", FW_NORMAL
AddRollerLine "for any action outwar may do", FW_NORMAL
AddRollerLine "if you are using my program.", FW_NORMAL
AddRollerLine "", 0
AddRollerLine "I'm also not responsible for any", FW_NORMAL
AddRollerLine "damage on your computer caused", FW_NORMAL
AddRollerLine "by this program", FW_NORMAL
AddRollerLine "", 0
AddRollerLine "Creating Auto-attackers isn't illegal :-)", FW_NORMAL
AddRollerLine "", 0
AddRollerLine "Ver: " & App.Major & "." & App.Minor & "." & App.Revision, FW_NORMAL

For A = 1 To lCount
    Buffer.Font = CreateFont(16, 0, 0, 0, Roller(A).Style, False, False, False, OEM_CHARSET, OUT_DEFAULT_PRECIS, CLIP_MASK, DEFAULT_QUALITY, 34, "Times New Roman")
    SelectObject Buffer.hdc, Buffer.Font
    SetRect Rect, 0, y + ((A - 1) * 16), Picture1.ScaleWidth, y + (A * 16)
    DrawTextA Buffer.hdc, Roller(A).Text, Len(Roller(A).Text), Rect, DT_CENTER
    DeleteObject Buffer.Font
Next

If y < -(lCount * 16) Then y = Buffer.ScaleHeight

BitBlt Picture1.hdc, 0, 0, Buffer.ScaleWidth, Buffer.ScaleHeight, Buffer.hdc, 0, 0, vbSrcCopy

Sleep 10
DoEvents
Loop

UnLoadBuffer

End Sub

Public Sub ClearRollerText()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "ClearRollerText()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Erase Roller
lCount = 0

End Sub

Public Sub AddRollerLine(Text As String, ByVal Style As Long)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "AddRollerLine(Text, Style)", Array(Text, Style), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

lCount = lCount + 1

ReDim Preserve Roller(1 To lCount)

Roller(lCount).Text = Text
Roller(lCount).Style = Style

End Sub

Private Sub Form_Unload(Cancel As Integer)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Form_Unload(Cancel)", Array(Cancel), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

UnLoadBuffer
Looping = False

End Sub

Public Sub StartSysInfo()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "StartSysInfo()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

    Dim rc As Long
    Dim SysInfoPath As String

    If GetKeyValue(HKEY_LOCAL_MACHINE, gREGKEYSYSINFO, gREGVALSYSINFO, SysInfoPath) Then
    ElseIf GetKeyValue(HKEY_LOCAL_MACHINE, gREGKEYSYSINFOLOC, gREGVALSYSINFOLOC, SysInfoPath) Then

        If (Dir(SysInfoPath & "\MSINFO32.EXE") <> "") Then
            SysInfoPath = SysInfoPath & "\MSINFO32.EXE"
    
        Else
            GoTo errHandler
        End If

    Else
        GoTo errHandler
    End If
    
    Call Shell(SysInfoPath, vbNormalFocus)

End Sub

Private Sub Label1_Click()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Label1_Click()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

ShellExecute Me.hwnd, vbNullString, Label1.Caption, vbNullString, "C:\", SW_SHOWNORMAL

End Sub
