VERSION 5.00
Begin VB.Form frmScript 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Script"
   ClientHeight    =   5835
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   5790
   HasDC           =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5835
   ScaleWidth      =   5790
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Options"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1455
      Left            =   240
      TabIndex        =   5
      Top             =   3480
      Width           =   5175
      Begin VB.ComboBox Combo1 
         Height          =   315
         ItemData        =   "frmScript.frx":0000
         Left            =   2400
         List            =   "frmScript.frx":000A
         Style           =   2  'Dropdown List
         TabIndex        =   8
         Top             =   480
         Width           =   2535
      End
      Begin VB.CheckBox Check1 
         Caption         =   "Async"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   960
         Width           =   2415
      End
      Begin VB.Label Label1 
         Caption         =   "Script type:"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   480
         Width           =   2415
      End
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Close"
      Height          =   375
      Left            =   4200
      TabIndex        =   2
      Top             =   5280
      Width           =   1335
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Top             =   5280
      Width           =   1335
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "&Open"
      Height          =   375
      Left            =   1560
      TabIndex        =   4
      Top             =   5280
      Width           =   1335
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "&Run"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   5280
      Width           =   1335
   End
   Begin VB.TextBox Code 
      Height          =   3135
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   5535
   End
End
Attribute VB_Name = "frmScript"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

' This program automates different actions within Outwar, an RPG-game.
'Copyright (C) 2004  Kristian S.Stangeland
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Dim CD1 As New OpenSave

Private Sub Check1_Click()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Check1_Click()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

SaveSetting "Outwar", "General", "AsyncScript", Check1.Value

End Sub

Private Sub cmdOpen_Click()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "cmdOpen_Click()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

CD1.Filter = "Outwar Tool Script (*.ows)" & Chr(0) & "*.ows"
CD1.OpenFile Me.hwnd, "Open Script"

If CD1.File = "" Then
    Exit Sub
End If

OpenFile CD1.File

End Sub

Public Sub Reset()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Reset()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Combo1.ListIndex = 0
Check1.Value = 1
Code.Text = ""

End Sub

Public Sub OpenFile(Path As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "OpenFile(Path)", Array(Path), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim strText$, Tmp&, Data(1) As Long

Tmp = FreeFile

Open Path For Binary As Tmp
    strText = Space(LOF(1))
    Get Tmp, , Data
    Get Tmp, , strText
Close Tmp

Combo1.ListIndex = Data(0)
Check1.Value = Data(1)
Code.Text = strText

End Sub

Private Sub cmdSave_Click()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "cmdSave_Click()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Data(1) As Long

CD1.Filter = "Outwar Tool Script (*.ows)" & Chr(0) & "*.ows"
CD1.SaveFile Me.hwnd, "Save Script"

If CD1.File = "" Then
    Exit Sub
End If

If Dir(CD1.File) <> "" Then
    Kill CD1.File
End If

Data(0) = Combo1.ListIndex
Data(1) = Check1.Value

Open CD1.File For Binary As #1
    Put #1, , Data
    Put #1, , Code.Text
Close #1

End Sub

Public Sub cmdRun_Click()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "cmdRun_Click()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Script As New clsScript

Script.Async = CBool(Check1.Value = 1)
' If async is off, "Exit connection at second byte arrival" has no effect

If cmdRun.Caption = "&Stop" Then
    cmdRun.Caption = "&Run"
    modScripting.AllStop = True
    Code.Locked = False
    Exit Sub
End If

Code.Locked = True
modScripting.AllStop = False
cmdRun.Caption = "&Stop"
Script.Async = CBool(Check1.Value = 1)

Set ScriptMe = Me
InvokeCode Script, Combo1.ListIndex, Code.Text

cmdRun.Caption = "&Run"
Code.Locked = False

End Sub

Private Sub Command2_Click()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Command2_Click()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Me.Hide
frmMain.Enabled = True

End Sub

Private Sub Form_Initialize()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Form_Initialize()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

EventStarted "Initialize", Me

Set ScriptMe = Me
Combo1.ListIndex = GetSetting("Outwar", "Advance", "DefaultLang", 1)

End Sub

Private Sub Form_Unload(Cancel As Integer)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Form_Unload(Cancel)", Array(Cancel), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

If DontCheck = True Then Exit Sub
frmMain.Enabled = True

End Sub
