Attribute VB_Name = "modScripting"
Option Explicit
Option Compare Text

' This program automates different actions within Outwar, an RPG-game.
'Copyright (C) 2004  Kristian S.Stangeland
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Public objScriptEn As Object

Private lAllStop As Boolean

Public Sub InvokeCode(Script As clsScript, ScriptType As Long, strCode As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "InvokeCode(ScriptType, strCode)", Array(ScriptType, strCode), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

On Error GoTo Feil
Dim Form As Form, ErrBefore&

Dim HTTP As clsHTTP
Dim API As cFuncCall
Dim OpenSave As OpenSave

Dim A&, B&, D, Tell&, Ini$

If Script.Async = True Then
    ' If it's async alloc enought sockets
    For A = 1 To frmMain.Attacks.count - 1
        Unload frmMain.Attacks(A)
    Next
    
    For A = 1 To GetSock(GetSetting("Outwar", "Auto", "Sockets", 0)) - 1
        Load frmMain.Attacks(A)
    Next
    
    ' So it understand that we only want to open a URL
    InvitePlayers = 7
End If

Select Case ScriptType
Case 0 ' Simple

    D = Split(strCode, vbNewLine)
    
    For A = LBound(D) To UBound(D)
        
        If Mid(D(A), 1, 1) = "/" Then
            RunScript CStr(D(A)), True
        Else
            Script.DownloadFile CStr(D(A))
        End If
        
        If lAllStop Then Exit Sub
        DoEvents
    Next

Case 1 ' VB-script

VBStart:
    objScriptEn.Language = "VBScript"
    objScriptEn.Reset
    objScriptEn.SitehWnd = frmScript.hwnd
    
    ' Add all forms
    For Each Form In Forms
        If InStr(1, strCode, Form.Name) <> 0 Then objScriptEn.AddObject Form.Name, Form
    Next
    
    Ini = "Const OutwarServer = " & Chr(34) & OutwarServer & Chr(34) & vbNewLine
    Ini = Ini & "Const strPage = " & Chr(34) & strPage & Chr(34) & vbNewLine
    Ini = Ini & "Const strProfile = " & Chr(34) & strProfile & Chr(34) & vbNewLine
    Ini = Ini & "Const strOutwar =" & Chr(34) & strOutwar & Chr(34) & vbNewLine
    Ini = Ini & "Const Ver = " & Chr(34) & App.Major & "." & App.Minor & "." & App.Revision & Chr(34) & vbNewLine
    
    If InStr(1, strCode, "HTTP") <> 0 Then Set HTTP = New clsHTTP: objScriptEn.AddObject "HTTP", HTTP
    If InStr(1, strCode, "Api") <> 0 Then Set API = New cFuncCall: objScriptEn.AddObject "Api", API
    If InStr(1, strCode, "OpenSave") <> 0 Then Set OpenSave = New OpenSave: objScriptEn.AddObject "OpenSave", OpenSave
    
    If InStr(1, strCode, "Main") <> 0 Then objScriptEn.AddObject "Main", Script
    If InStr(1, strCode, "Me") <> 0 Then objScriptEn.AddObject "Me", ScriptMe
    
    objScriptEn.AddCode Ini & strCode
End Select

Exit Sub
Feil:

If Err = 91 And ErrBefore = 0 Then
    Set objScriptEn = CreateObject("MSScriptControl.ScriptControl")
    ErrBefore = 1
    GoTo VBStart
Else
    MsgBox "Error number " & Err & ": " & Error, vbCritical, Err
End If

End Sub

Public Sub RunScript(Lines As String, Optional FromStartup As Boolean = True)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "RunScript(Lines, FromStartup)", Array(Lines, FromStartup), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim A, B, C&, Tmp&, E As Boolean, strData$

Tmp = InStr(1, Lines, "/")
B = Split(Mid(Lines, IIf(Tmp = 0, 1, Tmp)), "/")

For C = LBound(B) To UBound(B)

A = Split(B(C), " ", 3)

If UBound(A) > -1 Then
If A(0) <> "" Then

Select Case A(0)
Case "login"

    If UBound(A) > 1 Then
        frmLogin.txtUserName = A(1)
        frmLogin.txtPassword = A(2)
        frmLogin.cmdOK_Click
    End If

Case "usecookie"

    frmLogin.cmdUseCookie_Click

Case "linktorax": SaveSetting "Outwar", "General", "LinkTorax", Val(A(1))
Case "link": SaveSetting "Outwar", "General", "Link", A(1)
Case "noclick": SaveSetting "Outwar", "General", "DoNotClick", Val(A(1))
Case "transparent": SaveSetting "Outwar", "General", "TransparentKey", Val(A(1))
Case "sockets": SaveSetting "Outwar", "Auto", "Sockets", Val(A(1)): frmSettings.Command3_Click
Case "delay": frmSettings.Text5.Text = Val(A(1)): frmSettings.Command3_Click
Case "calcoutcome": frmSettings.Check6.Value = Val(A(1)): frmSettings.Command3_Click
Case "startatstartup": frmSettings.Check5.Value = Val(A(1)): frmSettings.Command3_Click
Case "selectcurrentitem": frmSettings.Check9.Value = Val(A(1)): frmSettings.Command3_Click
Case "openinbrowser": frmSettings.Check8.Value = Val(A(1)): frmSettings.Command3_Click
Case "checkforcode": frmSettings.Check7.Value = Val(A(1)): frmSettings.Command3_Click
Case "counthitlist": If LoggedIn Then frmMain.mnuHitListCount_Click
Case "crew": If LoggedIn Then frmMain.GetUsersFromCrew Val(A(1))
Case "startatstartup": frmSettings.Check5.Value = Val(A(1)): frmSettings.Command3_Click
Case "systray": frmSettings.Check3.Value = Val(A(1)): frmSettings.Command3_Click
Case "message": frmSettings.Text1.Text = CStr(A(1)): frmSettings.Command3_Click
Case "attacks": frmSettings.Text2.Text = Val(A(1)): frmSettings.Command3_Click
Case "reattack": frmSettings.txtReattack.Text = Val(A(1)): frmSettings.Command3_Click
Case "gethitlist": If LoggedIn Then frmMain.GetHitlist
Case "attackall": If LoggedIn Then frmMain.mnuAttackAll_Click
Case "inviteall": If LoggedIn Then frmMain.mnuInvite_Click
Case "checkall": If LoggedIn Then frmMain.mnuCheckAll_Click
Case "hitlistall": If LoggedIn Then Hitreason = A(1): frmMain.HitlistAll
Case "unhitlistall": If LoggedIn Then frmMain.UnHitListAll
Case "removeoutofrange": frmMain.mnuRABB_Click
Case "pagefrom": frmMain.Text1.Text = Val(A(1))
Case "pageto": frmMain.Text2.Text = Val(A(1))
Case "server": frmSettings.txtServer.Text = A(1): frmSettings.Command3_Click
Case "maxmoney": frmMain.Text3.Text = Val(A(1))
Case "search": If LoggedIn Then frmMain.Search_Click
Case "deletecache": frmSettings.DeleteCache_Click
Case "about": About.MainLoop
Case "exit": Unload frmMain
Case "nomanifest": E = True
Case "reset"
    
    If LCase(A(1)) = "settings" Then
        DeleteSetting "Outwar"
    End If

Case "run"

If Dir(A(1)) <> "" Then
    frmScript.OpenFile CStr(A(1))
    frmScript.cmdRun_Click
    frmScript.Reset
End If

Case "setscript"

    frmScript.Combo1.ListIndex = Val(A(1))
    frmScript.Code.Text = A(2)

Case "runscript"

    frmScript.cmdRun_Click
    If Val(A(1)) <> 0 Then frmScript.Reset

Case "resetscript"

    frmScript.Reset

Case Else:
    MsgBox "Invalid command: " & A(0), vbCritical, "Error"
End Select
End If
End If

Next

If Not E And FromStartup Then CheckForManifest

End Sub

Public Property Get AllStop() As Boolean
AllStop = lAllStop
End Property

Public Property Let AllStop(ByVal vNewValue As Boolean)
lAllStop = vNewValue
End Property
